package org.illeva.remcom.cmdsock;

import java.net.*;
import java.io.*;
import java.awt.event.*;

/**
  * E' il socket lato server che viene creato ad ogni richiesta che il ServerSocket riceve.
  */
public class ChildSocket extends Thread
{
	// Data members
	/** E' il canale di comunicazione che si apre fra i due socket. */
	private Socket dSock=null;
	/** E' l'applicazione target. */
	private SocketListener dApp=null;
	/** E' la Stringa da spedire. */
	private String dSend;
	// Funtction members
	/**
	  * E' il costruttore della classe.
	  */
	public ChildSocket(Socket aSock,SocketListener anApp)
	{
		dSock=aSock;
		dApp=anApp;
	} // end method
	/**
	  * Gestisce il protocollo di comunicazione, lato server, con il client.
	  */
	public void run()
	{
		try
		{
			PrintWriter vOs=new PrintWriter(dSock.getOutputStream(),true);
			BufferedReader vIs=new BufferedReader(new InputStreamReader(dSock.getInputStream()));
			int vStatus=1;
			dSend="Hy rcClient";
			String vReceive="";
			String vCmd=null;
			while(vStatus>0)
			{
				vOs.println(dSend);
				vReceive=vIs.readLine();
				if(vReceive.equals("Bye"))
					vStatus=0;
				else
					switch(vStatus)
					{
						case 1:
							if(vReceive.startsWith("Hy rcServer, i'm"))
							{
								vStatus=2;
								dSend="Sends command";
							} // end if
							else
							vStatus=0;
						break;
						case 2:
							if(vReceive.equals("Win(Close)"))
								vCmd=vReceive;
							else
							{
							  System.out.println("Esecuzione immediata: "+vReceive);
								executeCommand(vReceive);
						} // end else
							vStatus=3;
						break;
						default:
							vStatus=0;
					} // end switch
			} // end while
			vOs.close();
			dSock.close();
			/* Se alla fine del dialogo  stato ricevuto il comando, allora
			lo trasmette all'applicazione. */
			if(vCmd!=null)
				executeCommand(vCmd);
		} // end try
		catch(IOException anEx)
		{
			System.err.println(anEx);
		} // end catch
	} // end method
	/**
	  * Invia all'applicazione target il comando ricevuto dal client.
	  */
	protected void executeCommand(String aCmd)
	{
		// System.out.println(aCmd);
		String vCmd=null;
		SocketEvent vEvent=null;
		if(aCmd.startsWith("Win("))
		{
			vCmd=extractCommand("Win(",")",aCmd);
			if(vCmd.equals("Close"))
				vEvent=new SocketEvent(this,SocketEvent.WIN_CMD,SocketEvent.WIN_CLOSE);
			else if(vCmd.equals("Hide"))
				vEvent=new SocketEvent(this,SocketEvent.WIN_CMD,SocketEvent.WIN_HIDE);
			else if(vCmd.equals("Show"))
				vEvent=new SocketEvent(this,SocketEvent.WIN_CMD,SocketEvent.WIN_SHOW);
			else
				System.err.println("Unknow command: "+aCmd);
			if(vEvent!=null)
			{
				dSend="Executed command "+aCmd;
				dApp.processWinCommand(vEvent);
			} // end if
		} // end if
		else if(aCmd.startsWith("App("))
		{
			vCmd=extractCommand("App(",")",aCmd);
			if(vCmd.equals("CmdList"))
				vEvent=new SocketEvent(this,SocketEvent.APP_CMD,SocketEvent.APP_CMDLIST);
			else
				vEvent=new SocketEvent(this,SocketEvent.APP_CMD,SocketEvent.APP_PARAM,vCmd);
			dSend=dApp.processApplicationCommand(vEvent);
		} // end else if
	} // end method
	/**
	  * Estrae una sottostringa che rappresenta il comando specifico da eseguire, all'interno di una
	  * tipologia di comandi.
	  */
	private String extractCommand(String aBegin,String anEnd,String aCmd)
	{
		return aCmd.substring(aBegin.length(),aCmd.lastIndexOf(anEnd));
	} // end method
} // end class