package org.illeva.remcom.cmdsock;

import java.util.EventObject;

/**
  * E' l'evento che lapplicazione target deve gestire.
  */
public class SocketEvent extends EventObject
{
  /** E' un evento di tipo Window che in qualche modo riguarda la GUI dell'applicazione target */
	public static final int WIN_CMD=1;
	/** E' un evento di tipo applicativo. */
	public static final int APP_CMD=2;
	public static final int WIN_CLOSE=10;
	public static final int WIN_HIDE=11;
	public static final int WIN_SHOW=12;
	public static final int APP_PARAM=100;
	public static final int APP_CMDLIST=101;
	// Data members
	/** E' il tipo di evento da gestire */
	private int dType=0;
	/** E' il parametro dell'evento */
	private String dParam;
	/** E' il comando che va eseguito */
	private int dCommand=0;
	/** Ritorna il tipo di comando. */
	public int getType() {return dType;}
	/** Ritorna il comando da eseguire. */
	public int getCommand() {return dCommand;}
	/** Ritorna il parametro del comando. */
	public String getParam() {return dParam;}
	/**
	  * Costruttore dell'evento.
	  */
	public SocketEvent(Object aSource,int aType,int aCommand,String aParam)
	{
		super(aSource);
		dType=aType;
		dCommand=aCommand;
		dParam=aParam;
	} // end constructor
	/**
	  * Costruttore dell'evento con parametro nullo.
	  */
	public SocketEvent(Object aSource,int aType,int aCommand)
	{
		this(aSource,aType,aCommand,null);
	} // end constructor
} // end class