package org.illeva.remcom.gui;

import java.awt.*;
import java.awt.event.*;
import java.io.*;
import java.util.*;
import org.illeva.remcom.cmdsock.*;

/**
  * E' l'interfaccia del programma client.
  */
public class ClientWin extends Frame implements ActionListener,WindowListener,ItemListener
{
	// GUI elements
	/** E' la combo degli hosts target. */
	private Choice dHostsList=new Choice();
	/** E' la lista dei comandi che possono essere lanciati. */
	private java.awt.List dCmdList=new java.awt.List();
	/** E' il bottone di esecuzione del comando. */
	private Button dCmdButton=new Button("Execute");
	public ClientWin()
	{
		super("Remote Commander Client V1.0");
		add(dHostsList,BorderLayout.NORTH);
		add(dCmdList,BorderLayout.CENTER);
		add(dCmdButton,BorderLayout.EAST);
		dCmdButton.addActionListener(this);
		dHostsList.addItemListener(this);
		addWindowListener(this);
		loadHosts();
		refreshCommand(dHostsList.getItem(0).trim());
	} // end constructor
	public void actionPerformed(ActionEvent anEvent)
	{
		if(anEvent.getActionCommand().equals("Execute"))
		{
			int vPos=dCmdList.getSelectedIndex();
			int vPos2=dHostsList.getSelectedIndex();
			if(vPos!=-1 && vPos2!=-1)
				execute(dHostsList.getItem(vPos2).trim(),dCmdList.getItem(vPos).trim());
		} // end else if
			else
				System.out.println("Unknow WinCmd: "+anEvent.getActionCommand());
	} // end method
	public void windowActivated(WindowEvent anEvent)
	{
	} // end method
	public void windowClosed(WindowEvent anEvent)
	{
	} // end method
	public void windowClosing(WindowEvent anEvent)
	{
		System.exit(1);
	} // end method
	public void windowDeactivated(WindowEvent anEvent)
	{
	} // end method
	public void windowDeiconified(WindowEvent anEvent)
	{
	} // end method
	public void windowIconified(WindowEvent anEvent)
	{
	} // end method
	public void windowOpened(WindowEvent anEvent)
	{
	} // end method
	// Item listener method
	public void itemStateChanged(ItemEvent anEvent)
	{
		if(anEvent.getStateChange()==anEvent.SELECTED)
		{
			refreshCommand(dHostsList.getItem(dHostsList.getSelectedIndex()));
		} // end if
	} // end method
	/** Caricca la lista degli hosts target dal file di configurazione. */
	private void loadHosts()
	{
		try
		{
				BufferedReader vIs=new BufferedReader(new FileReader("../Config/hosts.txt"));
				String vLine=vIs.readLine();
				while(vLine!=null)
				{
					if(!vLine.startsWith("#"))
					{
						dHostsList.add(vLine);
					} // end if
					vLine=vIs.readLine();
				} // end while
		} // end try
		catch(FileNotFoundException anEx)
		{
			System.err.println(anEx);
		} // end catch
		catch(IOException anEx)
		{
			System.err.println(anEx);
		} // end catch
	} // end method
	/**
	  * Dato un host, viene inviata una richiesta all'host stesso per ricevere la
	  * lista dei comandi che su quell'host possono essere eseguiti.
	  */
	private void refreshCommand(String aHost)
	{
		String vCmdList=execute(aHost,"App(CmdList)");
		if(vCmdList!=null)
		{
			StringTokenizer vToken=new StringTokenizer(vCmdList.substring(8,vCmdList.length()-1),",");
			while(vToken.hasMoreElements())
				dCmdList.add(vToken.nextToken().trim());
		} // end if
	} // end method
	private String execute(String aHost,String aCmd)
	{
		int vBegin=aHost.indexOf("(");
		int vEnd=aHost.lastIndexOf(")");
		String vHost=aHost.substring(0,vBegin);
		int vPort=new Integer(aHost.substring(vBegin+1,vEnd)).intValue();
		Client vObj=new Client(vHost,vPort,aCmd);
		return vObj.run();
	} // end method
} // end class