package org.illeva.remcom.cmdsock;

import java.net.*;
import java.io.*;

/**
  * E' la classe che gestisce il protocollo di comunicazione, lato client. In pratica invia i comandi all'applicazione target.
  */
public class Client
{
	// Data members
	/** E' il canale di comunicazione */
	private Socket dSock=null;
	/** E' il comando da inviare */
	String dCmd;
	// Funtction members
	/**
	  * E' il costruttore della classe.
	  */
	public Client(String aHost,int aPort,String aCmd)
	{
		dCmd=aCmd;
		try
		{
			dSock=new Socket(aHost,aPort);
		} // end try
		catch(IOException anEx)
		{
			System.err.println(anEx);
		} // end catch
	} // end method
	/**
	  * Colloquia con il server per inviare il comando che deve essere eseguito dall'applicazione target.
	  */
	public String run()
	{
		String vRc="";
		try
		{
			PrintWriter vOs=new PrintWriter(dSock.getOutputStream(),true);
			BufferedReader vIs=new BufferedReader(new InputStreamReader(dSock.getInputStream()));
			int vStatus=1;
			String vReceive="";
			String vSend="";
			while(vStatus>0)
			{
				vReceive=vIs.readLine();
				System.out.println("[Rec] "+vReceive);
				switch(vStatus)
				{
					case 1:
						if(vReceive.startsWith("Hy rcClient"))
						{
							vSend="Hy rcServer, i'm user,password";
							vStatus=2;
						} // end if
						else
						{
							vSend="Bye";
							vStatus=0;
						} // end else
					break;
					case 2:
						if(vReceive.equals("Sends command"))
						{
							vSend=dCmd;
							vStatus=3;
						} // end if
						else
						{
							vSend="Bye";
							vStatus=0;
						} // end else
					break;
					case 3:
						if(vReceive.startsWith("Executed command"))
						{
							vSend="Bye";
							vStatus=0;
						} // end if
						else
						{
							vRc=vReceive;
							vSend="Bye";
							vStatus=0;
						} // end else
					break;
					default:
						vSend="Bye";
						vStatus=0;
				} // end switch
				vOs.println(vSend);
				System.out.println("[Send] "+vSend);
			} // end while
			vOs.close();
			dSock.close();
		} // end try
		catch(IOException anEx)
		{
			System.err.println(anEx);
		} // end catch
		return vRc;
	} // end method
} // end class